using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Phasma
{
    internal class cellDef
    {
        public int X, Y;

        List<Tile> tileStack = new List<Tile>();

        public void AddTile(Tile T)
        {
            tileStack.Add(T);
        }

        public void Clear()
        {
            tileStack.Clear();
        }

        public Color TopColor()
        {
            if (tileStack.Count == 0)
                return Color.Black;
            else
                return tileStack[tileStack.Count - 1].ForeColor;
        }

        public void DrawCell(Graphics G, Font F, int xO, int yO, int tileW, int tileH, int OL, int OT)
        {
            DrawCell(G, F, xO, yO, tileW, tileH, OL, OT, false);
        }

        public void DrawCell(Graphics G, Font F, int xO, int yO, int tileW, int tileH, int OL, int OT, bool useImages)
        {
            if (tileStack.Count == 0)
            {
                G.FillRectangle(Brushes.Black, (X * tileW) + xO, (Y * tileH) + yO, tileW, tileH);
                return;
            }
            else if (!useImages)
            {
                Tile top = tileStack[tileStack.Count - 1];
                G.FillRectangle(top.backBrush, (X * tileW) + xO, (Y * tileH) + yO, tileW, tileH);
                G.DrawString(top.Symbol.ToString(), F, top.foreBrush, (X * tileW) + xO - OL, (Y * tileH) + yO - OT);
            }
            else
            {
                G.FillRectangle(Brushes.Black, (X * tileW) + xO, (Y * tileH) + yO, tileW, tileH);
                foreach (Tile T in tileStack)
                {
                    if (T.Image != null)
                        G.DrawImage(T.Image, (X * tileW) + xO, (Y * tileH) + yO, tileW, tileH);
                }
            }
        }

        public char ToText()
        {
            if (tileStack.Count == 0)
                return ' ';
            else
                return tileStack[tileStack.Count - 1].Symbol;
        }
    }
}
