using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace PhasmaDemoApp
{
    class statsMain : Phasma.RLStats
    {
        public statsMain(int x, int y, int width, int height)
            : base(x, y, width, height)
        {
            //Build the various stats that can be displayed
            AddStat(new Phasma.statDef("Name", Phasma.statDef.StatTypes.Output, 0, 0));
            this["Name"].Color1 = Color.DodgerBlue;
            this["Name"].Color2 = Color.Blue;
            this["Name"].Value = "Nahjor";

            AddStat(new Phasma.statDef("Class", Phasma.statDef.StatTypes.KeylessOutput, 0, 2));
            this["Class"].Color2 = Color.Green;
            this["Class"].Value = "Code Monkey";

            AddStat(new Phasma.statDef("Attention", Phasma.statDef.StatTypes.Bar, 0, 3));
            this["Attention"].Color1 = Color.DodgerBlue;
            this["Attention"].Color2 = Color.Yellow;
            this["Attention"].Value = "10/100";

            //The flagListDef is a special kind of statDef that can have multiple boolean flags defined within it
            Phasma.flagListDef Flags = new Phasma.flagListDef("Flags", 1, 5);
            Flags.AddFlag("Hungry", "Hungry", Color.Orange, false);
            Flags.AddFlag("Tired", "Tired", Color.LightGreen, false);
            Flags.AddFlag("sick1", "Cold", Color.DodgerBlue, false);
            Flags.AddFlag("sick2", "Flu", Color.Chartreuse, false);
            myFlags = Flags;
            //Expose it
            AddStat(Flags);
        }

        //Property to allow us to easily grab the flag list that we've added from outside
        private Phasma.flagListDef myFlags;

        public Phasma.flagListDef Flags
        {
            get { return myFlags; }
            set { myFlags = value; }
        }

    }
}
